// Cube.cpp: implementation of the CCube class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "Cube.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

CCube::CCube(double r, double x, double y, double z, double rx, double ry, double rz, double vx, double vy, double vz, double vrx, double vry, double vrz, bool changeable)
{
	m_r = float(r);
	m_rx = rx;
	m_ry = ry;
	m_rz = rz;
	m_x = x;
	m_y = y;
	m_z = z;
	m_vrx = vrx;
	m_vry = vry;
	m_vrz = vrz;
	m_vx = vx;
	m_vy = vy;
	m_vz = vz;
	m_changeable = changeable;

	m_Texture.ReadFile("Marbre.bmp");
	m_Texture.BGRtoRGB();
	m_Texture.AddAlphaLayer(175);

	if (!m_changeable)
	{
		m_num_list = glGenLists(1);
		glNewList(m_num_list, GL_COMPILE_AND_EXECUTE);
			if(m_Texture.GetData() != NULL)
				glTexImage2D(GL_TEXTURE_2D,0,4, m_Texture.GetWidth(), m_Texture.GetHeight(),0,GL_RGBA,GL_UNSIGNED_BYTE, m_Texture.GetData());
			glBegin(GL_POLYGON);
				glNormal3d(0.0,0.0,1.0);
				glTexCoord2f(0.0, 1.0); glVertex3d(-m_r,  m_r, m_r);
				glTexCoord2f(1.0, 1.0); glVertex3d(-m_r, -m_r, m_r);
				glTexCoord2f(1.0, 0.0); glVertex3d( m_r, -m_r, m_r);
				glTexCoord2f(0.0, 0.0); glVertex3d( m_r,  m_r, m_r);
			glEnd();

			glBegin(GL_POLYGON);
				glNormal3d(0.0,0.0,-1.0);
				glTexCoord2f(0.0, 1.0); glVertex3d(  m_r,  m_r, -m_r);
				glTexCoord2f(0.0, 0.0); glVertex3d(  m_r, -m_r, -m_r);
				glTexCoord2f(1.0, 0.0); glVertex3d( -m_r, -m_r, -m_r);
				glTexCoord2f(1.0, 1.0); glVertex3d( -m_r,  m_r, -m_r);
			glEnd();

			glBegin(GL_POLYGON);
				glNormal3d(1.0,0.0,0.0);
				glTexCoord2f(0.0, 0.0); glVertex3d( m_r, m_r, m_r);
				glTexCoord2f(1.0, 0.0); glVertex3d( m_r, -m_r, m_r);
				glTexCoord2f(1.0, 1.0); glVertex3d( m_r, -m_r, -m_r);
				glTexCoord2f(0.0, 1.0); glVertex3d( m_r, m_r, -m_r);
			glEnd();

			glBegin(GL_POLYGON);
				glNormal3d(-1.0,0.0,0.0);
				glTexCoord2f(0.0, 0.0); glVertex3d( -m_r, m_r, m_r);
				glTexCoord2f(1.0, 0.0); glVertex3d( -m_r, m_r, -m_r);
				glTexCoord2f(1.0, 1.0); glVertex3d( -m_r, -m_r, -m_r);
				glTexCoord2f(0.0, 1.0); glVertex3d( -m_r, -m_r, m_r);
			glEnd();

			glBegin(GL_POLYGON);
				glNormal3d(0.0,-1.0,0.0);
				glTexCoord2f(0.0, 0.0); glVertex3d( -m_r, -m_r, m_r);
				glTexCoord2f(1.0, 0.0); glVertex3d( -m_r, -m_r, -m_r);
				glTexCoord2f(1.0, 1.0); glVertex3d( m_r, -m_r, -m_r);
				glTexCoord2f(0.0, 1.0); glVertex3d( m_r, -m_r, m_r);
			glEnd();

			glBegin(GL_POLYGON);
				glNormal3d(0.0,1.0,0.0);
				glTexCoord2f(0.0, 0.0); glVertex3d( -m_r, m_r, m_r);
				glTexCoord2f(1.0, 0.0); glVertex3d( m_r, m_r, m_r);
				glTexCoord2f(1.0, 1.0); glVertex3d( m_r, m_r, -m_r);
				glTexCoord2f(0.0, 1.0); glVertex3d( -m_r, m_r, -m_r);
			glEnd();

		glEndList();
	}
}

CCube::~CCube()
{
}

void CCube::Draw(float x, float y, float z)
{
	glPushMatrix();	
		glTranslated(m_x - x, m_y - y, m_z - z);
		glRotated(m_rx, 1.0, 0.0, 0.0);
		glRotated(m_ry, 0.0, 1.0, 0.0);
		glRotated(m_rz, 0.0, 0.0, 1.0);
		if (m_changeable)
		{
			if(m_Texture.GetData() != NULL)
				glTexImage2D(GL_TEXTURE_2D,0,4, m_Texture.GetWidth(), m_Texture.GetHeight(),0,GL_RGBA,GL_UNSIGNED_BYTE, m_Texture.GetData());
			glBegin(GL_POLYGON);
				glNormal3d(0.0,0.0,1.0);
				glTexCoord2f(0.0, 1.0); glVertex3d(-m_r,  m_r, m_r);
				glTexCoord2f(1.0, 1.0); glVertex3d(-m_r, -m_r, m_r);
				glTexCoord2f(1.0, 0.0); glVertex3d( m_r, -m_r, m_r);
				glTexCoord2f(0.0, 0.0); glVertex3d( m_r,  m_r, m_r);
			glEnd();

			glBegin(GL_POLYGON);
				glNormal3d(0.0,0.0,-1.0);
				glTexCoord2f(0.0, 1.0); glVertex3d(  m_r,  m_r, -m_r);
				glTexCoord2f(0.0, 0.0); glVertex3d(  m_r, -m_r, -m_r);
				glTexCoord2f(1.0, 0.0); glVertex3d( -m_r, -m_r, -m_r);
				glTexCoord2f(1.0, 1.0); glVertex3d( -m_r,  m_r, -m_r);
			glEnd();

			glBegin(GL_POLYGON);
				glNormal3d(1.0,0.0,0.0);
				glTexCoord2f(0.0, 0.0); glVertex3d( m_r, m_r, m_r);
				glTexCoord2f(1.0, 0.0); glVertex3d( m_r, -m_r, m_r);
				glTexCoord2f(1.0, 1.0); glVertex3d( m_r, -m_r, -m_r);
				glTexCoord2f(0.0, 1.0); glVertex3d( m_r, m_r, -m_r);
			glEnd();

			glBegin(GL_POLYGON);
				glNormal3d(-1.0,0.0,0.0);
				glTexCoord2f(0.0, 0.0); glVertex3d( -m_r, m_r, m_r);
				glTexCoord2f(1.0, 0.0); glVertex3d( -m_r, m_r, -m_r);
				glTexCoord2f(1.0, 1.0); glVertex3d( -m_r, -m_r, -m_r);
				glTexCoord2f(0.0, 1.0); glVertex3d( -m_r, -m_r, m_r);
			glEnd();

			glBegin(GL_POLYGON);
				glNormal3d(0.0,-1.0,0.0);
				glTexCoord2f(0.0, 0.0); glVertex3d( -m_r, -m_r, m_r);
				glTexCoord2f(1.0, 0.0); glVertex3d( -m_r, -m_r, -m_r);
				glTexCoord2f(1.0, 1.0); glVertex3d( m_r, -m_r, -m_r);
				glTexCoord2f(0.0, 1.0); glVertex3d( m_r, -m_r, m_r);
			glEnd();

			glBegin(GL_POLYGON);
				glNormal3d(0.0,1.0,0.0);
				glTexCoord2f(0.0, 0.0); glVertex3d( -m_r, m_r, m_r);
				glTexCoord2f(1.0, 0.0); glVertex3d( m_r, m_r, m_r);
				glTexCoord2f(1.0, 1.0); glVertex3d( m_r, m_r, -m_r);
				glTexCoord2f(0.0, 1.0); glVertex3d( -m_r, m_r, -m_r);
			glEnd();
		}
		else
			glCallList(m_num_list); 		
	glPopMatrix();
}

void CCube::Update(int t)
{
	m_x += m_vx * t;
	m_y += m_vy * t;
	m_z += m_vz * t;

	m_rx += m_vrx * t;
	m_ry += m_vry * t;
	m_rz += m_vrz * t;

}
